###########################
## Section 9 code
## Count and duration models
## Stephen Pettigrew

## set your working directory:
# setwd("")

## Count models

load("attacks.RData")
head(attacks)


# By hard coding our log likelihood:

pois.ll <- function(par, y, x){
  x <- as.matrix(cbind(1, x))
  xb <- x %*% par
  sum(y * xb - exp(xb))
}

opt.pois <- optim(par = rep(0,2),
                  fn = pois.ll,
                  x = attacks$unemploy,
                  y = attacks$deaths,
                  hessian = T,
                  method = "BFGS",
                  control = list(fnscale = -1))



# Or with Zelig:
require(Zelig)
zel.pois <- zelig(deaths ~ unemploy,
                  data = attacks,
                  model = "poisson")
summary(zel.pois)$coefficients




